import React, { useRef, useState, useEffect } from "react";
import TextField from '@mui/material/TextField';
import MenuItem from '@mui/material/MenuItem';
import 'react-confirm-alert/src/react-confirm-alert.css'; // Import css
import Button from '@mui/material/Button';
import axios from "axios";
import { getCookie, setCookie } from 'react-use-cookie';
import { useHistory } from "react-router-dom";
import CheckOut from "./CheckOut";
import { DataGrid, GridToolbar, frFR } from '@mui/x-data-grid';
import "react-draft-wysiwyg/dist/react-draft-wysiwyg.css";
import { Editor } from '@tinymce/tinymce-react';
import parse from 'html-react-parser';
import { FcViewDetails, FcDisapprove } from "react-icons/fc";
import 'react-tooltip/dist/react-tooltip.css'
import { Tooltip } from 'react-tooltip'
import add_plus from "../mysy_img/plus.png";
import excel_icone from "../mysy_img/excel_icone.png";
import participants from "../mysy_img/participants.png";
import fileDownload from 'js-file-download'
import Popup from 'reactjs-popup';
import 'reactjs-popup/dist/index.css';
import { FcCancel, FcApproval, FcAcceptDatabase, FcPrint, FcPlanner } from "react-icons/fc";
import DatePicker from "react-datepicker";
import "react-datepicker/dist/react-datepicker.css";
import { format } from 'date-fns'
import moment from "moment";
import InputAdornment from '@mui/material/InputAdornment';
import { AiFillCloseCircle } from "react-icons/ai";
import Box from '@mui/material/Box';
import { Typography, LinearProgress, sliderClasses } from '@mui/material';
import styled from 'styled-components';
import { CiTrash, CiBoxList } from "react-icons/ci";
import { MdAddCircleOutline, MdRemoveCircleOutline } from "react-icons/md";
import Dialog from '@mui/material/Dialog';
import DialogActions from '@mui/material/DialogActions';
import DialogContent from '@mui/material/DialogContent';
import DialogContentText from '@mui/material/DialogContentText';
import DialogTitle from '@mui/material/DialogTitle';
import { TransitionProps } from '@mui/material/transitions';
import img_loading_spin from "./../mysy_img/mysy_spin_loading.gif";
import FullCalendar from "@fullcalendar/react";
import daygridPlugin from "@fullcalendar/daygrid";
import interactionPlugin from "@fullcalendar/interaction";
import timeGridPlugin from "@fullcalendar/timegrid";

import allLocales from '@fullcalendar/core/locales-all'
import { RepeatOnRounded, RestaurantMenu } from "@mui/icons-material";
import { alignPropType } from "react-bootstrap/esm/types";

import ToggleSwitch from "./ToggleSwitch";
import Dashbord_Session_Par_Fteur from "./Dashbord_Session_Par_Fteur";
import Dashbord_Session_Taux_Remplissage from "./Dashbord_Session_Taux_Remplissage";
import Dashbord_Session_Repartition_Fteur from "./Dashbord_Session_Repartition_Fteur";


const Mon_Tableau_De_Bord = (props) => {


    const history = useHistory();
    const [isLoading, setLoading] = useState();


    const [Get_Connected_User_Dashbord_api, setGet_Connected_User_Dashbord_api] = useState();
    const [Get_Connected_User_Dashbord_message, setGet_Connected_User_Dashbord_message] = useState();
    const [Get_Connected_User_Dashbord_result, setGet_Connected_User_Dashbord_result] = useState();

    function Get_Connected_User_Dashbord() {

        var form = new FormData();
        const stored_cookie = getCookie('tokenmysypart');


        form.append("token", stored_cookie);


        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Connected_User_List_Dashbord/";

        //console.log(" ## myurl = ", myurl);

        setLoading(true);
        axios.post(myurl, form).then(res => {
            setLoading(false);
            if (String(res.data.status) === String("true")) {
                console.log(" In Get_Connected_User_Dashbord  res.data.status = " + res.data.status);
                console.log(" In Get_Connected_User_Dashbord  res.data.message r_class = " + res.data.message);

                setGet_Connected_User_Dashbord_api("true");
                setGet_Connected_User_Dashbord_result(res.data.message);

            }
            else {
                setGet_Connected_User_Dashbord_api("false");
                setGet_Connected_User_Dashbord_message(res.data.message);
                alert(res.data.message)
            }

        }).catch((error) => {
            setLoading(false);
            console.warn('Not good man :( Get_Connected_User_Dashbord = ', error);
            setGet_Connected_User_Dashbord_api("false");
            alert("Impossible de récupérer la liste des tableaux de bord");
            //setmyApimyApiMessage("")
        })
    }

    useEffect(() => {


        Get_Connected_User_Dashbord();
        window.scrollTo({
            top: 0,
            behavior: "smooth",
        });

    }, [])



    return (
        <div className="mon_tableau_de_bord">
            {isLoading && <div className="loader-container">
                <div className="mysy_spinner">  <img src={img_loading_spin} />  </div>
            </div>}

            <h3> Mon tableau de bord </h3>

            La liste de mes tableaux de bord <br />


            {Get_Connected_User_Dashbord_result &&
                Get_Connected_User_Dashbord_result.map((step) => (
                    <div className="div_row">
                        {JSON.parse(step).dashbord_internal_code}&nbsp; Filtre :   {JSON.parse(step).default_filter}


                        {String(JSON.parse(step).dashbord_internal_code) === "tbd_code_session_01" &&
                            <div>
                                <Dashbord_Session_Taux_Remplissage />
                            </div>}

                        {String(JSON.parse(step).dashbord_internal_code) === "tbd_code_session_02" &&
                            <div>
                                <Dashbord_Session_Par_Fteur />

                            </div>}


                        {String(JSON.parse(step).dashbord_internal_code) === "tbd_code_session_03" &&
                            <div>

                                <Dashbord_Session_Repartition_Fteur />
                            </div>}


                    </div>

                ))}



        </div>
    )
}


export default Mon_Tableau_De_Bord;